// VsimView.cpp : CVsimView NX̓̒`s܂B
//

#include "stdafx.h"

#include "Vsim.h"

#include "VsimDoc.h"
#include "VsimView.h"

#include "SetupDlg.h"

#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib, "winmm.lib")

/////////////////////////////////////////////////////////////////////////////
// CVsimView

IMPLEMENT_DYNCREATE(CVsimView, CScrollView)

BEGIN_MESSAGE_MAP(CVsimView, CScrollView)
	//{{AFX_MSG_MAP(CVsimView)
	ON_COMMAND(ID_SETUP, OnSetup)
	ON_COMMAND(ID_RUN, OnRun)
	ON_COMMAND(ID_STOP, OnStop)
	ON_COMMAND(ID_FREQ, OnFreq)
	ON_COMMAND(ID_WAVE, OnWave)
	ON_COMMAND(ID_FFT, OnFFT)
	//}}AFX_MSG_MAP
	ON_MESSAGE(MM_WOM_DONE, CVsimView::OnPlayData)
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVsimView NX̍\z/

CVsimView::CVsimView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
    enable1  = TRUE;
	freq1    = 1000;
	gain1_db = 10;
    enable2  = FALSE;
	freq2    = 0;
	gain2_db = 0;
    enable3  = FALSE;
	freq3    = 0;
	gain3_db = 0;
    enable4  = FALSE;
	freq4    = 0;
	gain4_db = 0;
    enable5  = FALSE;
	freq5    = 0;
	gain5_db = 0;

    freq6    = 1000; //HPF

    w_freq   = 1000; //Opg
	w_duty   = 50;
    w_rise   = 50;
	w_fall   = 50;

	wave_on = 0;
	db_max  = 20;
	db_div  = 10;

	x_10 = 0;
	x_11 = 0;
	x_12 = 0;
	x_13 = 0;
	x_14 = 0;
	x_15 = 0;
	x_21 = 0;
	x_22 = 0;
	x_23 = 0;
	x_24 = 0;
	x_25 = 0;

	draw_freq = 1;
	draw_w    = 0;
	draw_fft  = 0;
}

CVsimView::~CVsimView()
{
}

BOOL CVsimView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//       CĂB

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CVsimView NX̕`

void CVsimView::OnDraw(CDC* pDC)
{
	CVsimDoc* pDoc = GetDocument();
	//ASSERT_VALID(pDoc);

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	int i, k, x;
	CRect rect;

	GetClientRect(rect);
    pDC->SetMapMode(MM_ANISOTROPIC);
    pDC->SetWindowExt(760, 640);
    pDC->SetViewportExt(rect.Width(), (int)(300*rect.Width()/640));

    CPen R_Pen(PS_SOLID, 1, RGB(255,0,0));
    CPen G_Pen(PS_SOLID, 1, RGB(0,255,0));
    CPen B_Pen(PS_SOLID, 1, RGB(0,0,255));
    CPen* pOldPen;

    pOldPen = pDC->SelectObject(&B_Pen);

	if (draw_freq)
	{
       for (i=0; i<20; i++)
       {
          pDC->MoveTo(  20, 20+i*30 );
          pDC->LineTo( 500, 20+i*30 );
       }

       i = 0;
       while (i<2)
       {
          for (k=1; k<11; k++)
          {
             x = (int)(240*log10(k));
             pDC->MoveTo( 20+x+240*i,  20 );
             pDC->LineTo( 20+x+240*i, 620 );
          }
          i ++;
       }

	   pDC->SelectObject(&R_Pen);
       pDC->MoveTo(  20, 20+5*30 );
       pDC->LineTo( 500, 20+5*30 );
    }

	if (draw_w)
	{
	   for (i = 0; i<21; i++)
	   {
		  pDC->MoveTo(20, 20 + i * 30);
		  pDC->LineTo(740, 20 + i * 30);
	   }
	   for (i = 0; i<21; i++)
	   {
		  pDC->MoveTo(20 + 720 * i / 20, 20);
		  pDC->LineTo(20 + 720 * i / 20, 620);
	   }
	}

	if (draw_fft)
	{
	   for (i = 0; i<21; i++)
	   {
		  pDC->MoveTo(20, 20 + i * 30);
		  pDC->LineTo(740, 20 + i * 30);
	   }
	   for (i = 0; i<21; i++)
	   {
		  pDC->MoveTo(20 + 720 * i / 20, 20);
		  pDC->LineTo(20 + 720 * i / 20, 620);
	   }
	}

	pDC->SelectObject(&R_Pen);
    if (m_pointArray0.GetSize())
	{
		pDC->MoveTo( m_pointArray0[0] );
		for( int i=1; i< m_pointArray0.GetSize(); i++)
		{
			 pDC->LineTo( m_pointArray0[i] );
		}
	}

    pDC->SelectObject(pOldPen);

}

void CVsimView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: ̃r[̃TCY̍vvZ܂B
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CVsimView NẌ

BOOL CVsimView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg CScrollView ̈
	return CScrollView::OnPreparePrinting(pInfo);
}

void CVsimView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// ftHg CScrollView ̑O
	CScrollView::OnBeginPrinting(pDC, pInfo);
}

void CVsimView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// ftHg CScrollView ̈̌㏈
	CScrollView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CVsimView NX̐ff

#ifdef _DEBUG
void CVsimView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CVsimView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CVsimDoc* CVsimView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVsimDoc)));
	return (CVsimDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVsimView NX̃bZ[W nh


void CVsimView::OnSetup() 
{
	CSetupDlg dlg;
	CString   str;

	double  q;
	double  f0;

    dlg.m_enable1 = enable1;
    dlg.m_freq1   = freq1;
    dlg.m_gain1   = gain1_db;
    dlg.m_enable2 = enable2;
    dlg.m_freq2   = freq2;
    dlg.m_gain2   = gain2_db;
    dlg.m_enable3 = enable3;
    dlg.m_freq3   = freq3;
    dlg.m_gain3   = gain3_db;
    dlg.m_enable4 = enable4;
    dlg.m_freq4   = freq4;
    dlg.m_gain4   = gain4_db;
    dlg.m_enable5 = enable5;
    dlg.m_freq5   = freq5;
    dlg.m_gain5   = gain5_db;
	dlg.m_w_freq  = w_freq;
	dlg.m_w_duty  = w_duty;
	dlg.m_w_rise  = w_rise;
	dlg.m_w_fall  = w_fall;

	if (dlg.DoModal() == IDOK)
	{
		enable1 = dlg.m_enable1;
		if (enable1 == TRUE)
		{
			freq1 = dlg.m_freq1;
			gain1_db = dlg.m_gain1;
			gain1 = pow(10,gain1_db/20);
			q = gain1*sqrt(1+sqrt(1-1/(gain1*gain1))/2);
			q += gain1*sqrt(1-sqrt(1-1/(gain1*gain1))/2);
			q = q/2;
	        f0 = freq1/sqrt(1-1/(2*q*q));

			a1 = 1/q;
			t1 = 8.0 * atan(1.0) * f0 / FREQUENCY;
			tt1 = 8.0 * atan(1.0) * f0 / FREQ_FFT;
		}
		enable2 = dlg.m_enable2;
		if (enable2 == TRUE)
		{
			freq2 = dlg.m_freq2;
			gain2_db = dlg.m_gain2;
            gain2 = pow(10,gain2_db/20);
			q = gain2*sqrt(1+sqrt(1-1/(gain2*gain2))/2);
			q += gain2*sqrt(1-sqrt(1-1/(gain2*gain2))/2);
			q = q/2;
	        f0 = freq2/sqrt(1-1/(2*q*q));

			a2 = 1/q;
			t2 = 8.0 * atan(1.0) * f0 / FREQUENCY;
			tt2 = 8.0 * atan(1.0) * f0 / FREQ_FFT;
		}
		enable3 = dlg.m_enable3;
		if (enable3 == TRUE)
		{
			freq3 = dlg.m_freq3;
			gain3_db = dlg.m_gain3;
			gain3 = pow(10,gain3_db/20);
			q = gain3*sqrt(1+sqrt(1-1/(gain3*gain3))/2);
			q += gain3*sqrt(1-sqrt(1-1/(gain3*gain3))/2);
			q = q/2;
	        f0 = freq3/sqrt(1-1/(2*q*q));

			a3 = 1/q;
			t3 = 8.0 * atan(1.0) * f0 / FREQUENCY;
			tt3 = 8.0 * atan(1.0) * f0 / FREQ_FFT;
		}
		enable4 = dlg.m_enable4;
		if (enable4 == TRUE)
		{
			freq4 = dlg.m_freq4;
			gain4_db = dlg.m_gain4;
			gain4 = pow(10,gain4_db/20);
			q = gain4*sqrt(1+sqrt(1-1/(gain4*gain4))/2);
			q += gain4*sqrt(1-sqrt(1-1/(gain4*gain4))/2);
			q = q/2;
	        f0 = freq4/sqrt(1-1/(2*q*q));
			
			a4 = 1/q;
			t4 = 8.0 * atan(1.0) * f0 / FREQUENCY;
			tt4 = 8.0 * atan(1.0) * f0 / FREQ_FFT;
		}
		enable5 = dlg.m_enable5;
		if (enable5 == TRUE)
		{
			freq5 = dlg.m_freq5;
			gain5_db = dlg.m_gain5;
			gain5 = pow(10,gain5_db/20);
			q = gain5*sqrt(1+sqrt(1-1/(gain5*gain5))/2);
			q += gain5*sqrt(1-sqrt(1-1/(gain5*gain5))/2);
			q = q/2;
	        f0 = freq5/sqrt(1-1/(2*q*q));
			
			a5 = 1/q;
			t5 = 8.0 * atan(1.0) * f0 / FREQUENCY;
			tt5 = 8.0 * atan(1.0) * f0 / FREQ_FFT;
		}

		t6 = 8.0 * atan(1.0) * freq6 / FREQUENCY;
        tt6 = 8.0 * atan(1.0) * freq6 / FREQ_FFT;

		w_freq = dlg.m_w_freq;
		w_duty = dlg.m_w_duty;
		w_rise = dlg.m_w_rise;
		w_fall = dlg.m_w_fall;

	}
}

void CVsimView::OnRun() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int  i;

    al   = 0;
	al_w = 0;

	if (wave_on) return;
	wave_on = 1;

	wf.wFormatTag = WAVE_FORMAT_PCM;
	wf.nChannels = 1;
	wf.nSamplesPerSec = FREQUENCY;
	wf.nAvgBytesPerSec = FREQUENCY * 2;
	wf.nBlockAlign = 2;
	wf.wBitsPerSample = 16;
	wf.cbSize = 0;

	for (i = 0; i < BLOCK_NUMS; i++)
	{
		memset(bufOut[i], '\0', ONE_BLOCK_DATA_NUM * 2);
		whOut[i].lpData = (char *)bufOut[i];
		whOut[i].dwBufferLength = ONE_BLOCK_DATA_NUM * 2;
		whOut[i].dwBytesRecorded = 0;
		whOut[i].dwUser = 0;
		whOut[i].dwFlags = 0;
		whOut[i].dwLoops = 1;
		whOut[i].lpNext = NULL;
		whOut[i].reserved = 0;
	}
	
	MMRESULT mmrError = waveOutOpen(&hWOut, WAVE_MAPPER, &wf, (DWORD)m_hWnd, 0, CALLBACK_WINDOW);
	for (i = 0; i < BLOCK_NUMS; i++)
	{
		memset(bufOut[i], '\0', ONE_BLOCK_DATA_NUM * 2);
		PreparePlayData(i);
		whOut[i].dwFlags = 0;
		waveOutPrepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
		waveOutWrite(hWOut, &whOut[i], sizeof(WAVEHDR));
	}
	
}

afx_msg LRESULT CVsimView::OnPlayData(WPARAM wParam, LPARAM lParam)
{
	for (int i = 0; i < BLOCK_NUMS; i++)
	{
		if ((whOut[i].dwFlags & WHDR_DONE) == WHDR_DONE)
		{
			PreparePlayData(i);
			waveOutUnprepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
			waveOutPrepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
			waveOutWrite(hWOut, &whOut[i], sizeof(WAVEHDR));
			break;
		}
	}
	return 0;
}

void CVsimView::PreparePlayData(int nBlock)
{
    //static double al = 0.0;

	double  k1 = sqrt(1 - a1*a1 / 4);
	double  k2 = sqrt(1 - a2*a2 / 4);
	double  k3 = sqrt(1 - a3*a3 / 4);
	double  k4 = sqrt(1 - a4*a4 / 4);
	double  k5 = sqrt(1 - a5*a5 / 4);

	double  ux1 = a1*(1 - exp(-a1*t1 / 2)*cos(k1*t1)) + (1 - a1*a1 / 2)*exp(-a1*t1 / 2)*sin(k1*t1) / k1;
	double  ux2 = 1 - exp(-a1*t1 / 2)*(cos(k1*t1) + a1*sin(k1*t1) / (2 * k1));
	//BPF
    //double  ux1 = -1 + exp(-a1*t1 / 2)*cos(k1*t1) + a1*exp(-a1*t1 / 2)*sin(k1*t1) / (2 * k1);
	//double  ux2 = exp(-a1*t1 / 2)*sin(k1*t1) / k1;

	double  ux3 = a2*(1 - exp(-a2*t2 / 2)*cos(k2*t2)) + (1 - a2*a2 / 2)*exp(-a2*t2 / 2)*sin(k2*t2) / k2;
	double  ux4 = 1 - exp(-a2*t2 / 2)*(cos(k2*t2) + a2*sin(k2*t2) / (2 * k2));
	//BPF
    //double  ux3 = -1 + exp(-a1*t2 / 2)*cos(k2*t2) + a1*exp(-a1*t2 / 2)*sin(k2*t2) / (2 * k2);
	//double  ux4 = exp(-a1*t2 / 2)*sin(k2*t2) / k2;

	double  ux5 = a3*(1 - exp(-a3*t3 / 2)*cos(k3*t3)) + (1 - a3*a3 / 2)*exp(-a3*t3 / 2)*sin(k3*t3) / k3;
	double  ux6 = 1 - exp(-a3*t3 / 2)*(cos(k3*t3) + a3*sin(k3*t3) / (2 * k3));
	double  ux7 = a4*(1 - exp(-a4*t4 / 2)*cos(k4*t4)) + (1 - a4*a4 / 2)*exp(-a4*t4 / 2)*sin(k4*t4) / k4;
	double  ux8 = 1 - exp(-a4*t4 / 2)*(cos(k4*t4) + a4*sin(k4*t4) / (2 * k4));
	double  ux9 = a5*(1 - exp(-a5*t5 / 2)*cos(k5*t5)) + (1 - a5*a5 / 2)*exp(-a5*t5 / 2)*sin(k5*t5) / k5;
	double  ux10 = 1 - exp(-a5*t5 / 2)*(cos(k5*t5) + a5*sin(k5*t5) / (2 * k5));

	double  x10, x20, u, y, x;
	double  pif = 8.0 * atan(1.0) * w_freq;

	for (int i = 0; i < ONE_BLOCK_DATA_NUM; i++)
	{
		u = 10000 * sin(al); // sin
		//u = 10000 * wave_in(al); //Opg

		x10 = exp(-a1*t1 / 2)*(x_11*cos(k1*t1) + (a1*x_11 / 2 - x_21)*sin(k1*t1) / k1) + ux1*u;
		x20 = exp(-a1*t1 / 2)*(x_21*cos(k1*t1) - (a1*x_21 / 2 - x_11)*sin(k1*t1) / k1) + ux2*u;
		x_11 = x10;
		x_21 = x20;

		if (enable2 == TRUE)
		{
		    x10 = exp(-a2*t2 / 2)*(x_12*cos(k2*t2) + (a2*x_12 / 2 - x_22)*sin(k2*t2) / k2) + ux3*x20;
		    x20 = exp(-a2*t2 / 2)*(x_22*cos(k2*t2) - (a2*x_22 / 2 - x_12)*sin(k2*t2) / k2) + ux4*x20;
		    x_12 = x10;
		    x_22 = x20;
		}
        if (enable3 == TRUE)
		{
		    x10 = exp(-a3*t3 / 2)*(x_13*cos(k3*t3) + (a3*x_13 / 2 - x_23)*sin(k3*t3) / k3) + ux5*x20;
		    x20 = exp(-a3*t3 / 2)*(x_23*cos(k3*t3) - (a3*x_23 / 2 - x_13)*sin(k3*t3) / k3) + ux6*x20;
		    x_13 = x10;
		    x_23 = x20;
		}
        if (enable4 == TRUE)
		{
		    x10 = exp(-a4*t4 / 2)*(x_14*cos(k4*t4) + (a4*x_14 / 2 - x_24)*sin(k4*t4) / k4) + ux7*x20;
		    x20 = exp(-a4*t4 / 2)*(x_24*cos(k4*t4) - (a4*x_24 / 2 - x_14)*sin(k4*t4) / k4) + ux8*x20;
		    x_14 = x10;
		    x_24 = x20;
		}
        if (enable5 == TRUE)
		{
		    x10 = exp(-a5*t5 / 2)*(x_15*cos(k5*t5) + (a5*x_15 / 2 - x_25)*sin(k5*t5) / k5) + ux9*x20;
		    x20 = exp(-a5*t5 / 2)*(x_25*cos(k5*t5) - (a5*x_25 / 2 - x_15)*sin(k5*t5) / k5) + ux10*x20;
		    x_15 = x10;
		    x_25 = x20;
		}

		//HPF : 1KHz
		//x10 = exp(-t6)*x_10 + (1 - exp(-t6))*x20;
		//x_10 = x10;
		//y = -exp(-t6)*x_10 + exp(-t6)*x20;
		
		y = x20;

		bufOut[nBlock][i] = (short)y;
		//bufOut[nBlock][i] = (short)(10000* sin(al));
		//bufOut[nBlock][i] = (short)(10000 * wave_in(al));
		al += pif / FREQUENCY;

	    x = al / (8.0 * atan(1.0));
	    if (1.0 < x)
		    al = al - 8.0 * atan(1.0);

        //CString  str;
		//str.Format("wave : %f : %d ", al, bufOut[nBlock][i]);
        //AfxMessageBox(str,MB_OK,0);
	}
}

void CVsimView::OnStop() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ

    waveOutReset(hWOut);
	for (int i = 0; i < BLOCK_NUMS; i++)
	{
		waveOutUnprepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
	}
	waveOutClose(hWOut);

	wave_on = 0;
}

void CVsimView::graph(double *al)
{
	x = log10(freq/start_freq);
    a = (db_max-(*al))/db_div;
	if (freq>start_freq)
    {
       draw_line(&x0, &a0, &x, &a, &cl, &start);
	   start = 0;
    }
    x0 = x;
    a0 = a;
}

void CVsimView::draw_line(double *x1, double *y1, double *x2, double *y2, unsigned char *cl, unsigned char *start)
{
   double x, y;
   char draw;

   draw = 1;

   CRect rect;

   CClientDC  dc (this);
   CScrollView::OnPrepareDC(&dc,NULL);

   GetClientRect(rect);
   dc.SetMapMode(MM_ANISOTROPIC);
   dc.SetWindowExt(760,640);
   dc.SetViewportExt(rect.Width(), (int)(300*rect.Width()/640));

   CPen R_Pen(PS_SOLID, 1, RGB(255,0,0));
   CPen G_Pen(PS_SOLID, 1, RGB(255,0,255));
   CPen* pOldPen;

   dc.SelectStockObject(NULL_BRUSH);

   if (*cl==0) pOldPen = dc.SelectObject(&R_Pen);

   x = *x1;
   y = *y1;
   if (draw) dc.MoveTo( (int)(20+240*x), (int)(20+30*y) );
   if (*cl==0)  m_pointArray0.Add( CPoint( (int)(20+240*x), (int)(20+30*y) ) );

   x = *x2;
   y = *y2;
   if (draw) dc.LineTo( (int)(20+240*x), (int)(20+30*y) );
      
   if (*cl==0)  m_pointArray0.Add( CPoint( (int)(20+240*x), (int)(20+30*y) ) );
 
   dc.SelectObject(pOldPen);
}

void CVsimView::OnFreq() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ

	double  q;
	double  f0;

    draw_freq = 1;
	draw_w    = 0;
	draw_fft  = 0;

    m_pointArray0.RemoveAll();

	CWnd::Invalidate(TRUE);
    CWnd::UpdateWindow();  

	cl = 0;
	start = 1;
	db_max = 50;
	db_div = 10;
	start_freq = 100;
	freq = start_freq;

	do {

		al = 0;

	    if (enable1 == TRUE)
		{
			q = gain1*sqrt(1+sqrt(1-1/(gain1*gain1))/2);
			q += gain1*sqrt(1-sqrt(1-1/(gain1*gain1))/2);
			q = q/2;
	        f0 = freq1/sqrt(1-1/(2*q*q));
            *gr = 1-(freq/f0)*(freq/f0);
	        *gi = (1/q)*freq/f0;

	        al += -10*log10((*gr)*(*gr)+(*gi)*(*gi));
		}
        if (enable2 == TRUE)
		{
			q = gain2*sqrt(1+sqrt(1-1/(gain2*gain2))/2);
			q += gain2*sqrt(1-sqrt(1-1/(gain2*gain2))/2);
			q = q/2;
	        f0 = freq2/sqrt(1-1/(2*q*q));
            *gr = 1-(freq/f0)*(freq/f0);
	        *gi = (1/q)*freq/f0;

	        al += -10*log10((*gr)*(*gr)+(*gi)*(*gi));
		}
        if (enable3 == TRUE)
		{
			q = gain3*sqrt(1+sqrt(1-1/(gain3*gain3))/2);
			q += gain3*sqrt(1-sqrt(1-1/(gain3*gain3))/2);
			q = q/2;
	        f0 = freq3/sqrt(1-1/(2*q*q));
            *gr = 1-(freq/f0)*(freq/f0);
	        *gi = (1/q)*freq/f0;

	        al += -10*log10((*gr)*(*gr)+(*gi)*(*gi));
		}
        if (enable4 == TRUE)
		{
			q = gain4*sqrt(1+sqrt(1-1/(gain4*gain4))/2);
			q += gain4*sqrt(1-sqrt(1-1/(gain4*gain4))/2);
			q = q/2;
	        f0 = freq4/sqrt(1-1/(2*q*q));
            *gr = 1-(freq/f0)*(freq/f0);
	        *gi = (1/q)*freq/f0;

	        al += -10*log10((*gr)*(*gr)+(*gi)*(*gi));
		}
        if (enable5 == TRUE)
		{
			q = gain5*sqrt(1+sqrt(1-1/(gain5*gain5))/2);
			q += gain5*sqrt(1-sqrt(1-1/(gain5*gain5))/2);
			q = q/2;
	        f0 = freq5/sqrt(1-1/(2*q*q));
            *gr = 1-(freq/f0)*(freq/f0);
	        *gi = (1/q)*freq/f0;

	        al += -10*log10((*gr)*(*gr)+(*gi)*(*gi));
		}
        //HPF
		//*gr = 1;
		//*gi = freq6/freq;
        //al += -10*log10((*gr)*(*gr)+(*gi)*(*gi));

        graph(&al);

	    if (freq < 1000)
		    freq += 10;
	    else
		    freq += 100;

	} while (freq < 10100);

}

void CVsimView::OnWave() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ

	double x, y, x0, y0;
	char draw;
	CRect  rect;
	int   i;
	CClientDC  dc(this);

    draw_freq = 0;
	draw_w    = 1;
	draw_fft  = 0;

    m_pointArray0.RemoveAll();

	CWnd::Invalidate(TRUE);
    CWnd::UpdateWindow(); 

    CScrollView::OnPrepareDC(&dc,NULL);

	GetClientRect(rect);
	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(760, 640);
	dc.SetViewportExt(rect.Width(), (int)(300*rect.Width()/640));

	CPen R_Pen(PS_SOLID, 1, RGB(255, 0, 0));
	CPen B_Pen(PS_SOLID, 1, RGB(0, 0, 255));
	CPen* pOldPen;

	pOldPen = dc.SelectObject(&B_Pen);

	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20, 20 + i * 30);
		dc.LineTo(740, 20 + i * 30);
	}
	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20 + 720 * i / 20, 20);
		dc.LineTo(20 + 720 * i / 20, 620);
	}

	dc.SelectStockObject(NULL_BRUSH);

	dc.MoveTo(20, 320);
	dc.LineTo(740, 320);

	pOldPen = dc.SelectObject(&R_Pen);

	dc.MoveTo(20, 320);
	dc.LineTo(740, 320);

	PreparePlayData(0);

	if (draw)
	{
		for (i = 0; i < ONE_BLOCK_DATA_NUM; i++)
		{
			y = bufOut[0][i];
			x = (double)i * 3 / ONE_BLOCK_DATA_NUM;
			y = 10 * (1 - y*0.00005);  // Wϊ
			if (i != 0)
				draw_wave(x0, y0, x, y);
			x0 = x;
			y0 = y;
		}
	}

	dc.SelectObject(pOldPen);
}

void CVsimView::draw_wave(double x1, double y1, double x2, double y2)
{
	// range x : 0-3  y : 0-20

	double x, y;
	CClientDC  dc(this);
	CRect  rect;

	GetClientRect(rect);
    dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(760, 640);
	dc.SetViewportExt(rect.Width(), (int)(300*rect.Width()/640));

	CPen R_Pen(PS_SOLID, 1, RGB(255, 0, 0));
	CPen* pOldPen;

	dc.SelectStockObject(NULL_BRUSH);

	pOldPen = dc.SelectObject(&R_Pen);

	x = x1;
	y = y1;
	dc.MoveTo((int)(20 + 240 * x), (int)(20 + 30 * y));
	m_pointArray0.Add(CPoint((int)(20 + 240 * x), (int)(20 + 30 * y)));
	x = x2;
	y = y2;
	dc.LineTo((int)(20 + 240 * x), (int)(20 + 30 * y));
	m_pointArray0.Add(CPoint((int)(20 + 240 * x), (int)(20 + 30 * y)));

	dc.SelectObject(pOldPen);
}

double CVsimView::wave_in(double al)
{
    double  pif = 8.0 * atan(1.0) * 500 / FREQUENCY;
    double  w_dt;

    double x;
    double y;

	al_w += pif;

	x = al / (8.0 * atan(1.0));
	//x = x * (1 + 0.5 * sin (al_w));

	w_dt = w_duty; // * (1 + 0.2 * sin (al_w));

	//Opg
	y = 4.0 * x; // 0 < y < 4
	if (0.75 < x)
	{
        y = y - 4.0;
	}
	else if (0.25 < x)
    {
        y = 2.0 - y;
	}

	if (w_rise)
	{
		if (x < (w_rise / 100) )
		{
		    y = x * 100 / w_rise;
		}
		else 
		{
			if (x < (w_dt / 100) )
			{
                y = 1.0;
			}
			else
			{
                if (x < ( (w_dt + w_fall) / 100) )
		        {
			        y = (1.0 - (100 * x - w_dt) / w_fall);
		        }
		        else
			        y = 0;
			}
		}
	}

	//y = y *  (1 + 0.2 * sin (al_w));

	return y;
}

void CVsimView::OnFFT() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
    static double al = 0.0;

	double  k1 = sqrt(1 - a1*a1 / 4);
	double  k2 = sqrt(1 - a2*a2 / 4);
	double  k3 = sqrt(1 - a3*a3 / 4);
	double  k4 = sqrt(1 - a4*a4 / 4);
	double  k5 = sqrt(1 - a5*a5 / 4);

	double  ux1 = a1*(1 - exp(-a1*tt1 / 2)*cos(k1*tt1)) + (1 - a1*a1 / 2)*exp(-a1*tt1 / 2)*sin(k1*tt1) / k1;
	double  ux2 = 1 - exp(-a1*tt1 / 2)*(cos(k1*tt1) + a1*sin(k1*tt1) / (2 * k1));
	//BPF
    //double  ux1 = -1 + exp(-a1*tt1 / 2)*cos(k1*tt1) + a1*exp(-a1*tt1 / 2)*sin(k1*tt1) / (2 * k1);
	//double  ux2 = exp(-a1*tt1 / 2)*sin(k1*tt1) / k1;

	double  ux3 = a2*(1 - exp(-a2*tt2 / 2)*cos(k2*tt2)) + (1 - a2*a2 / 2)*exp(-a2*tt2 / 2)*sin(k2*tt2) / k2;
	double  ux4 = 1 - exp(-a2*tt2 / 2)*(cos(k2*tt2) + a2*sin(k2*tt2) / (2 * k2));
	//BPF
    //double  ux3 = -1 + exp(-a1*tt2 / 2)*cos(k2*tt2) + a1*exp(-a1*tt2 / 2)*sin(k2*tt2) / (2 * k2);
	//double  ux4 = exp(-a1*tt2 / 2)*sin(k2*tt2) / k2;

	double  ux5 = a3*(1 - exp(-a3*tt3 / 2)*cos(k3*tt3)) + (1 - a3*a3 / 2)*exp(-a3*tt3 / 2)*sin(k3*tt3) / k3;
	double  ux6 = 1 - exp(-a3*tt3 / 2)*(cos(k3*tt3) + a3*sin(k3*tt3) / (2 * k3));
	double  ux7 = a4*(1 - exp(-a4*tt4 / 2)*cos(k4*tt4)) + (1 - a4*a4 / 2)*exp(-a4*tt4 / 2)*sin(k4*tt4) / k4;
	double  ux8 = 1 - exp(-a4*tt4 / 2)*(cos(k4*tt4) + a4*sin(k4*tt4) / (2 * k4));
	double  ux9 = a5*(1 - exp(-a5*tt5 / 2)*cos(k5*tt5)) + (1 - a5*a5 / 2)*exp(-a5*tt5 / 2)*sin(k5*tt5) / k5;
	double  ux10 = 1 - exp(-a5*tt5 / 2)*(cos(k5*tt5) + a5*sin(k5*tt5) / (2 * k5));

	double  x10, x20, u, y;

    int     i;

    x_10 = 0;
	x_11 = 0;
	x_12 = 0;
	x_13 = 0;
	x_14 = 0;
	x_15 = 0;
	x_21 = 0;
	x_22 = 0;
	x_23 = 0;
	x_24 = 0;
	x_25 = 0;

	for (i = 0; i < 2048; i++)
	{
		if (i)
		    u = 0;
		else
		    u = 1;

		x10 = exp(-a1*tt1 / 2)*(x_11*cos(k1*tt1) + (a1*x_11 / 2 - x_21)*sin(k1*tt1) / k1) + ux1*u;
		x20 = exp(-a1*tt1 / 2)*(x_21*cos(k1*tt1) - (a1*x_21 / 2 - x_11)*sin(k1*tt1) / k1) + ux2*u;
		x_11 = x10;
		x_21 = x20;

		if (enable2 == TRUE)
		{
		    x10 = exp(-a2*tt2 / 2)*(x_12*cos(k2*tt2) + (a2*x_12 / 2 - x_22)*sin(k2*tt2) / k2) + ux3*x20;
		    x20 = exp(-a2*tt2 / 2)*(x_22*cos(k2*tt2) - (a2*x_22 / 2 - x_12)*sin(k2*tt2) / k2) + ux4*x20;
		    x_12 = x10;
		    x_22 = x20;
		}
        if (enable3 == TRUE)
		{
		    x10 = exp(-a3*tt3 / 2)*(x_13*cos(k3*tt3) + (a3*x_13 / 2 - x_23)*sin(k3*tt3) / k3) + ux5*x20;
		    x20 = exp(-a3*tt3 / 2)*(x_23*cos(k3*tt3) - (a3*x_23 / 2 - x_13)*sin(k3*tt3) / k3) + ux6*x20;
		    x_13 = x10;
		    x_23 = x20;
		}
        if (enable4 == TRUE)
		{
		    x10 = exp(-a4*tt4 / 2)*(x_14*cos(k4*tt4) + (a4*x_14 / 2 - x_24)*sin(k4*tt4) / k4) + ux7*x20;
		    x20 = exp(-a4*tt4 / 2)*(x_24*cos(k4*tt4) - (a4*x_24 / 2 - x_14)*sin(k4*tt4) / k4) + ux8*x20;
		    x_14 = x10;
		    x_24 = x20;
		}
        if (enable5 == TRUE)
		{
		    x10 = exp(-a5*tt5 / 2)*(x_15*cos(k5*tt5) + (a5*x_15 / 2 - x_25)*sin(k5*tt5) / k5) + ux9*x20;
		    x20 = exp(-a5*tt5 / 2)*(x_25*cos(k5*tt5) - (a5*x_25 / 2 - x_15)*sin(k5*tt5) / k5) + ux10*x20;
		    x_15 = x10;
		    x_25 = x20;
		}

		//HPF : 1KHz
        //x10 = exp(-tt6)*x_10 + (1 - exp(-tt6))*x20;
		//x_10 = x10;
		//y = -exp(-tt6)*x_10 + exp(-tt6)*x20;

		y = x20;

		c0[i] = y;
		c1[i] = 0;
	}
	fast();
	Graph_FFT();
}

void CVsimView::fast()
{
    double  x;
	double  t0, t1;
	double  th;
	double  cs, sn;
	double  g;
	int     i, j, k;
	int     ii, jj, kk;
	int     kmax, istep;

	x = 0;
	for (i = 0; i < 2048; i++)
		x = x + c0[i];
	x = x / 2048;
	for (i = 0; i < 2048; i++)
		c0[i] += x;

	for (i = 0; i < 2048; i++)
	{
		ii = i;
		jj = 0;
		kk = 2048;
		for (j = 1; j < 12; j++)
		{
			kk = kk / 2;
			jj = jj + kk*(ii % 2);
			ii = int(ii / 2);
		}
		j = jj;
		if (j > i)
		{
			t0 = c0[j];
			t1 = c1[j];
			c0[j] = c0[i];
			c1[j] = c1[i];
			c0[i] = t0;
			c1[i] = t1;
		}
	}
	kmax = 1;
	do
	{
		istep = kmax * 2;
		for (k = 0; k < kmax; k++)
		{
			th = -4.0 * atan(1.0) * k / kmax;
			cs = cos(th);
			sn = sin(th);
			for (i = k; i < 2048; i += istep)
			{
				j = i + kmax;
				t0 = c0[j] * cs - c1[j] * sn;
				t1 = c0[j] * sn + c1[j] * cs;
				c0[j] = c0[i] - t0;
				c1[j] = c1[i] - t1;
				c0[i] = c0[i] + t0;
				c1[i] = c1[i] + t1;
			}
		}
		kmax = istep;
	} while (kmax < 2048);

	bufOut[0][0] = 0;
	for (i = 1; i < ONE_BLOCK_DATA_NUM/2; i++)
	{
		g = c0[i] * c0[i] + c1[i] * c1[i];
		g = sqrt(g);
		bufOut[0][i] = (short)(20 * log10(g));
	}
}

void CVsimView::Graph_FFT()
{
	// range x : 0-3  y : 0-20

	double x, y, x0, y0;
	char draw;
	CRect  rect;
	CClientDC  dc(this);
	int   i;

    draw_freq = 0;
	draw_w    = 0;
	draw_fft  = 1;

    m_pointArray0.RemoveAll();

	CWnd::Invalidate(TRUE);
    CWnd::UpdateWindow();  

    CScrollView::OnPrepareDC(&dc,NULL);

	GetClientRect(rect);
	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(760, 640);
	dc.SetViewportExt(rect.Width(), (int)(300*rect.Width()/640));

	CPen R_Pen(PS_SOLID, 1, RGB(255, 0, 0));
	CPen B_Pen(PS_SOLID, 1, RGB(0, 0, 255));
	CPen* pOldPen;

	pOldPen = dc.SelectObject(&B_Pen);

	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20, 20 + i * 30);
		dc.LineTo(740, 20 + i * 30);
	}
	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20 + 720 * i / 20, 20);
		dc.LineTo(20 + 720 * i / 20, 620);
	}

	dc.SelectStockObject(NULL_BRUSH);

	dc.MoveTo(20, 320);
	dc.LineTo(740, 320);

	pOldPen = dc.SelectObject(&R_Pen);

	dc.MoveTo(20, 320);
	dc.LineTo(740, 320);

	if (draw)
	{
		for (i = 0; i < ONE_BLOCK_DATA_NUM/2; i++)
		{
			y = bufOut[0][i];

			x = (double)i * 12 / ONE_BLOCK_DATA_NUM;
			y = 10 * (1 - y*0.01); // 10dB/div, max 20KHz
			if (i > 1000)
				break;
			
		    if (i != 0)
				draw_FFT(x0, y0, x, y);
			x0 = x;
			y0 = y;
		}
	}

	dc.SelectObject(pOldPen);
}

void CVsimView::draw_FFT(double x1, double y1, double x2, double y2)
{
	// range x : 0-3  y : 0-20

	double x, y;
	CClientDC  dc(this);
	CRect  rect;

	GetClientRect(rect);

	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(760, 640);
	dc.SetViewportExt(rect.Width(), (int)(300*rect.Width()/640));

	CPen R_Pen(PS_SOLID, 1, RGB(255, 0, 0));
	CPen* pOldPen;

	dc.SelectStockObject(NULL_BRUSH);

	pOldPen = dc.SelectObject(&R_Pen);

	x = x1;
	y = y1;
	dc.MoveTo((int)(20 + 240 * x), (int)(20 + 30 * y));
	m_pointArray0.Add(CPoint((int)(20 + 240 * x), (int)(20 + 30 * y)));
	x = x2;
	y = y2;
	dc.LineTo((int)(20 + 240 * x), (int)(20 + 30 * y));
	m_pointArray0.Add(CPoint((int)(20 + 240 * x), (int)(20 + 30 * y)));

	dc.SelectObject(pOldPen);
}
